import { BranchInfo } from ".";
import { CommitSearchOptions } from "../Commit";
import { Commit } from "../Commit/commit";
import { GitlabApiClientBase } from "../GitlabApiClientBase/gitlabApiClientBase";
import { MergeRequest } from "../MergeRequest/mergeRequest";
import { PipelineSearchOptions } from "../Pipeline";
import { Pipeline } from "../Pipeline/pipeline";
import { GitlabOptions } from "../Gitlab";
import { NewMergeRequestOptions } from "../MergeRequest";
export interface Branch extends BranchInfo {
}
export declare class Branch extends GitlabApiClientBase {
    private projectId;
    constructor(branchInfo: BranchInfo, options: Required<GitlabOptions>, projectId: number);
    getMergeRequest(): Promise<MergeRequest | null>;
    findCommits(searchOptions?: Omit<CommitSearchOptions, "ref_name">): Promise<Commit[]>;
    findPipelines(searchOptions?: Omit<PipelineSearchOptions, "ref_name">): Promise<Pipeline[]>;
    createPipeline(): Promise<Pipeline>;
    createMergeRequest(mergeRequestInfo: Omit<NewMergeRequestOptions, "source_branch">): Promise<MergeRequest>;
    delete(): Promise<void>;
}
