"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Commit = void 0;
const GitlabApiClientBase_1 = require("../GitlabApiClientBase");
const gitlabApiClientBase_1 = require("../GitlabApiClientBase/gitlabApiClientBase");
const pipeline_1 = require("../Pipeline/pipeline");
class Commit extends gitlabApiClientBase_1.GitlabApiClientBase {
    constructor(commitInfo, options, projectId, branchName) {
        super(options);
        this.projectId = projectId;
        this.branchName = branchName;
        this.projectId = projectId;
        this.branchName = branchName;
        Object.assign(this, commitInfo);
    }
    findPipelines(searchOptions = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            const { data } = yield this.CallGitlabApi({
                endpoint: `/projects/${this.id}/repository/commits/${this.short_id}/pipelines`,
                method: GitlabApiClientBase_1.Methods.GET,
                expectedStatusCode: 200,
                params: searchOptions,
            });
            return data.map((pipelineInfo) => new pipeline_1.Pipeline(pipelineInfo, this.options));
        });
    }
    revert() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.branchName)
                throw new Error("Cannot revert commit not initiated from a branch");
            const { data } = yield this.CallGitlabApi({
                endpoint: `/projects/${this.projectId}/repository/commits/${this.short_id}/revert`,
                method: GitlabApiClientBase_1.Methods.FORM_POST,
                expectedStatusCode: 201,
                data: { branch: this.branchName },
            });
            return new Commit(data, this.options, this.projectId);
        });
    }
}
exports.Commit = Commit;
