import { GitlabApiClientBase } from "../GitlabApiClientBase/gitlabApiClientBase";
import { Project } from "../Project/project";
import { GitlabCreateProjectOptions, ProjectSearchOptions } from "../Project";
import { Group } from "../Group/group";
import { GroupCreateOptions, GroupSeatchOptions } from "../Group";
import { GitlabOptions } from ".";
import { RestrictedUser } from "../User/user";
import { UserSearchOptions } from "../User";
export declare class Gitlab extends GitlabApiClientBase {
    constructor(partialOptions?: GitlabOptions);
    resetCache(): void;
    findProjects(searchOptions?: ProjectSearchOptions): Promise<Project[]>;
    findGroups(searchOptions?: GroupSeatchOptions): Promise<Group[]>;
    findUsers(searchOptions?: UserSearchOptions): Promise<RestrictedUser>;
    createProject(projectOptions: GitlabCreateProjectOptions): Promise<Project>;
    createGroup(groupName: GroupCreateOptions): Promise<Group>;
}
