"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Group = void 0;
const GitlabApiClientBase_1 = require("../GitlabApiClientBase");
const gitlabApiClientBase_1 = require("../GitlabApiClientBase/gitlabApiClientBase");
const project_1 = require("../Project/project");
class Group extends gitlabApiClientBase_1.GitlabApiClientBase {
    constructor(groupInfo, options) {
        super(options);
        Object.assign(this, groupInfo);
    }
    findProjects(searchOptions = {}) {
        return __awaiter(this, void 0, void 0, function* () {
            const { data } = yield this.CallGitlabApi({
                endpoint: `/groups/${this.id}/projects`,
                method: GitlabApiClientBase_1.Methods.GET,
                expectedStatusCode: 200,
                params: searchOptions,
            });
            return data.map((project) => new project_1.Project(project, this.options));
        });
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.CallGitlabApi({
                endpoint: `/groups/${this.id}`,
                method: GitlabApiClientBase_1.Methods.DELETE,
                expectedStatusCode: 204,
            });
        });
    }
}
exports.Group = Group;
