"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Issue = void 0;
const gitlabApiClientBase_1 = require("../GitlabApiClientBase/gitlabApiClientBase");
const GitlabApiClientBase_1 = require("../GitlabApiClientBase");
class Issue extends gitlabApiClientBase_1.GitlabApiClientBase {
    constructor(issueInfo, options) {
        super(options);
        Object.assign(this, issueInfo);
    }
    delete() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.CallGitlabApi({
                endpoint: `/projects/${this.project_id}/issues/${this.iid}`,
                method: GitlabApiClientBase_1.Methods.DELETE,
                expectedStatusCode: 204,
            });
        });
    }
}
exports.Issue = Issue;
