/// <reference types="node" />
import { JobInfo, JobVariableAttribute } from ".";
import { GitlabApiClientBase } from "../GitlabApiClientBase/gitlabApiClientBase";
import { GitlabOptions } from "../Gitlab";
import { Commit } from "../Commit/commit";
import { Pipeline } from "../Pipeline/pipeline";
export interface Job extends Omit<JobInfo, "commit" | "pipeline"> {
}
export declare class Job extends GitlabApiClientBase {
    private projectId;
    commit: Commit;
    pipeline: Pipeline;
    constructor(jobInfo: JobInfo, options: Required<GitlabOptions>, projectId: number);
    downloadArtifacts(): Promise<Buffer>;
    cancel(): Promise<void>;
    retry(): Promise<Job>;
    erase(): Promise<void>;
    play(jobVariablesAttributes: JobVariableAttribute[]): Promise<void>;
}
