import { MergeRequestInfo } from ".";
import { Branch } from "../Branch/branch";
import { GitlabApiClientBase } from "../GitlabApiClientBase/gitlabApiClientBase";
import { Pipeline } from "../Pipeline/pipeline";
import { GitlabOptions } from "../Gitlab";
import { PipelineSearchOptions } from "../Pipeline";
export interface MergeRequest extends MergeRequestInfo {
}
export declare class MergeRequest extends GitlabApiClientBase {
    constructor(mergeRequestInfo: MergeRequestInfo, options: Required<GitlabOptions>);
    getBranch(): Promise<Branch>;
    findPipelines(searchOptions?: Omit<PipelineSearchOptions, "ref_name">): Promise<Pipeline[]>;
    delete(): Promise<void>;
    merge(): Promise<void>;
}
