import { ProjectInfo } from ".";
import { BranchSearchOptions } from "../Branch";
import { Branch } from "../Branch/branch";
import { CommitSearchOptions } from "../Commit";
import { Commit } from "../Commit/commit";
import { File } from "../File/file";
import { GitlabApiClientBase } from "../GitlabApiClientBase/gitlabApiClientBase";
import { Issue } from "../Issue/issue";
import { MergeRequestSearchOptions } from "../MergeRequest";
import { MergeRequest } from "../MergeRequest/mergeRequest";
import { PipelineSearchOptions } from "../Pipeline";
import { Pipeline } from "../Pipeline/pipeline";
import { GitlabOptions } from "../Gitlab";
import { IssueCreateOptions, IssueSearchOptions } from "../Issue";
export interface Project extends ProjectInfo {
}
export declare class Project extends GitlabApiClientBase {
    constructor(projectInfo: ProjectInfo, options: Required<GitlabOptions>);
    findBranches(searchOptions?: BranchSearchOptions): Promise<Branch[]>;
    findMergeRequests(searchOptions?: MergeRequestSearchOptions): Promise<MergeRequest[]>;
    findCommits(searchOptions?: CommitSearchOptions): Promise<Commit[]>;
    findPipelines(searchOptions?: PipelineSearchOptions): Promise<Pipeline[]>;
    findIssues(searchOptions?: IssueSearchOptions): Promise<Issue[]>;
    getFile(filePath: string, ref: string): Promise<File>;
    createBranch(branchName: string, sourceBranchName: string): Promise<Branch>;
    createIssue(issue?: IssueCreateOptions): Promise<Issue>;
    archive(): Promise<void>;
    unArchive(): Promise<void>;
    delete(): Promise<void>;
}
